<template lang="pug">
title-bar FAQ
b-container
	.tile.is-ancestor
		form.tile.is-vertical( @submit.prevent='save' )
			.tile.is-parent
				b-card.tile.is-child( title="RU" ): faq-list( store="ru" :loading='pending' )
			.tile.is-parent
				b-card.tile.is-child( title="EN" ): faq-list( store="en" :loading='pending' )
</template>

<script setup>
	import FaqList from "@/components/faq/FaqList.vue"

	import { ref, computed, onMounted, watch } from "vue"

	import { useSettingsStore } from "@/stores/settings"
	import { useToast } from "vue-toastification"
	import { useI18n } from "vue-i18n"

	const toast = useToast()
	const { t } = useI18n()
	const { getSetting, editSetting, get } = useSettingsStore()

	const pending = ref(false)

	const faq = computed(() => get("faq") || { ru: [], en: [] })

	const fetch = async () => {
		await getSetting("faq")
	}

	const save = async () => {
		if (pending.value) return

		let data = Object.keys(faq.value).map(locale => ({
			field_name: "faq",
			field_value: JSON.stringify(faq.value[locale]),
			lang: locale
		}))

		pending.value = true

		try {
			await editSetting("faq", data)
			await fetch()
			toast.success(t("default.changes_saved"))
		} catch(err) {
			console.error(err)
		}

		pending.value = false
	}

	onMounted(async () => {
		if (!get("faq"))
			await fetch()
	})
</script>

<style lang="scss" scoped>

</style>